!=========================================================================
! Copyright (C) GemTalk Systems 1986-2015.  All Rights Reserved.
!
! $Id: nameless.gs,v 1.7 2008-01-09 19:02:34 stever Exp $
!
! Description - Create the Nameless user account.
! 
! Repository conversion - this file is used
!
!=======================================================================

! login as SystemUser
set user SystemUser pass swordfish
iferror exit
login 
iferror

expectvalue %String
run
   "Expect a four element Array of user IDs: SystemUser, DataCurator,
    GcUser and Nameless "
| nameless newSegment newUser gcUserGlobals |

nameless := AllUsers detect: [ :x | x userId = 'Nameless' ] ifNone: [nil].
nameless ~~ nil
  ifTrue: [
    "Nameless already exists. Set its password."
    nameless password: 'swordfish'.
    ^ 'Nameless already exists'
    ]
  ifFalse: [
    "Create a new Nameless user account"
    newSegment := Segment newInRepository: SystemRepository.
    newUser := UserProfile newWithUserId: 'Nameless'
                         password: #swordfish
                         defaultSegment: newSegment
                         privileges: #()
                         inGroups: #()
                         compilerLanguage: #ASCII.
    newSegment worldAuthorization: #write;
             owner: newUser.

    " AllUsers add: newUser. --- no longer needed "

    " Put Nameless in SystemUser's UserGlobals "
    UserGlobals at: #Nameless put: newUser.

    " Put Nameless in DataCurator's UserGlobals"
    ((AllUsers userWithId: #DataCurator) resolveSymbol: #UserGlobals) value at: 
       #Nameless put: newUser.

    " Put Nameless in its own UserGlobals"
    gcUserGlobals := (newUser resolveSymbol: #UserGlobals) value.
    gcUserGlobals at: #Nameless put: newUser.

    ^ 'created Nameless'
    ]
%

commit

logout

